<?php

namespace Drupal\tmgmt_xtm\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\tmgmt\Entity\Job;
use Drupal\tmgmt_xtm\Plugin\tmgmt\Translator\Connector;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;

/**
 * Class RemoteCallbackController
 * @package Drupal\tmgmt_xtm\Controller
 */
class RemoteCallbackController extends ControllerBase
{
  const TMGMT_JOB = 'tmgmt_job';
  const TMGMT_JOB_ID = 'xtmJobId';
  const XTM_PROJECT_ID = 'xtmProjectId';


  /**
   * @param Request $request
   *
   * @return Response
   */
  public function callback(Request $request)
  {
    \Drupal::logger('xtm')->debug('Request received.');
    $tmgmtJobIDs = explode(
      ",",
      htmlspecialchars_decode(filter_var($_REQUEST[Connector::TMGMT_JOB_ID], FILTER_SANITIZE_STRING))
    );
    $data['xtmProjectId'] = (int)filter_var($_REQUEST[self::XTM_PROJECT_ID], FILTER_SANITIZE_NUMBER_INT);
    if (empty($data['xtmProjectId'])) {
      return new Response('Bad request.', 400);
    }
    $data['tmgmtJobIds'] = $tmgmtJobIDs;
    $data['xtmJobId'] = (int)filter_var($_REQUEST[self::TMGMT_JOB_ID], FILTER_SANITIZE_NUMBER_INT);
    $queue = \Drupal::queue('callback_job_queue');
    $queue->createQueue();
    $queue->createItem($data);

    return new Response();
  }
}
