<?php


namespace Drupal\tmgmt_xtm\Plugin\tmgmt\Requirement;


/**
 * Class SoapRequirement
 * @package Drupal\tmgmt_xtm\Plugin\tmgmt\Requirement
 */
class SoapRequirement implements RequirementInterface
{

  /**
   * @param $phase
   * @return array
   */
  public function check($phase)
  {
    if (($phase == 'runtime') && (!extension_loaded('soap'))) {
      $requirements['soap'] = [
        'title' => t('SOAP Disabled'),
        'description' => t('SOAP extension is disabled. Make sure the <a href=":url" target="_blank">PHP SOAP</a> package is installed.', [
          ':url' => 'https://www.php.net/manual/en/book.soap.php',
        ]),
        'severity' => REQUIREMENT_ERROR,
        'value' => t('Never run'),
      ];

      return $requirements;
    }
  }
}
